# radarbox
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.3.9
- Package version: 1.0.0
- Generator version: 7.10.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import radarbox
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import radarbox
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import radarbox
from radarbox.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.radarbox.com/v2
# See configuration.py for a list of all supported configuration parameters.
configuration = radarbox.Configuration(
    host = "https://api.radarbox.com/v2"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: bearerToken
configuration = radarbox.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with radarbox.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = radarbox.AircraftApi(api_client)
    mode_s = 'A98909' # str | Mode-S code (optional)
    registration = 'N713UW' # str | Registration (optional)
    include_statistics = true # bool | Include statistics (optional)
    start_month = '2023-01' # str | Statistics start month (yyyy-MM) (optional)
    end_month = '2023-03' # str | Statistics end month (yyyy-MM) (optional)

    try:
        # Aircraft by ID
        api_response = api_instance.get_aircraft(mode_s=mode_s, registration=registration, include_statistics=include_statistics, start_month=start_month, end_month=end_month)
        print("The response of AircraftApi->get_aircraft:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AircraftApi->get_aircraft: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.radarbox.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AircraftApi* | [**get_aircraft**](docs/AircraftApi.md#get_aircraft) | **GET** /aircraft | Aircraft by ID
*AircraftApi* | [**search_aircraft**](docs/AircraftApi.md#search_aircraft) | **GET** /aircraft/search | Aircraft search
*AirportsApi* | [**get_airport**](docs/AirportsApi.md#get_airport) | **GET** /airports/{icaoCode} | Airport by code
*AirportsApi* | [**get_datis**](docs/AirportsApi.md#get_datis) | **GET** /airports/{icaoCode}/datis | Get D-ATIS by airport
*AirportsApi* | [**get_metar**](docs/AirportsApi.md#get_metar) | **GET** /airports/{icaoCode}/metar | Get METAR by airport
*AirportsApi* | [**get_taf**](docs/AirportsApi.md#get_taf) | **GET** /airports/{icaoCode}/taf | Get TAF by airport
*AirportsApi* | [**search_airport**](docs/AirportsApi.md#search_airport) | **GET** /airports/search | Airport search
*AirspaceApi* | [**get_nat_tracks**](docs/AirspaceApi.md#get_nat_tracks) | **GET** /airspace/natTracks | NAT (North Atlantic Tracks)
*AirspaceApi* | [**get_notams**](docs/AirspaceApi.md#get_notams) | **GET** /airspace/{icaoCode}/notams | Get NOTAMS by airport
*AirspaceApi* | [**get_pac_tracks**](docs/AirspaceApi.md#get_pac_tracks) | **GET** /airspace/pacTracks | PAC (Pacific Organized Track System - PACOTS) 
*BillingApi* | [**status**](docs/BillingApi.md#status) | **GET** /billing/status | Get the current billing status
*BillingApi* | [**usage**](docs/BillingApi.md#usage) | **GET** /billing/usage | Get the latest token usage statistics
*FlightsApi* | [**aircraft_position**](docs/FlightsApi.md#aircraft_position) | **POST** /flights/live | Get live flights 
*FlightsApi* | [**geosearch**](docs/FlightsApi.md#geosearch) | **POST** /flights/geosearch | Search flights by geographical area
*FlightsApi* | [**get_scheduled_flights**](docs/FlightsApi.md#get_scheduled_flights) | **GET** /flights/schedules | Get scheduled flights
*FlightsApi* | [**search**](docs/FlightsApi.md#search) | **POST** /flights/search | Search flights
*StatisticsApi* | [**get_airline_statistics**](docs/StatisticsApi.md#get_airline_statistics) | **GET** /statistics/airline/{icaoCode} | Statistics for a specific airline
*StatisticsApi* | [**get_airlines_statistics**](docs/StatisticsApi.md#get_airlines_statistics) | **GET** /statistics/airlines | Statistics for major airlines
*StatisticsApi* | [**get_bus_jet_models_statistics_internal**](docs/StatisticsApi.md#get_bus_jet_models_statistics_internal) | **GET** /statistics/flights/business/models | Statistics for business jet models
*StatisticsApi* | [**get_bus_jet_operator_statistics_internal**](docs/StatisticsApi.md#get_bus_jet_operator_statistics_internal) | **GET** /statistics/flights/business/operators | Statistics for business jet operators
*StatisticsApi* | [**get_business_airport_statistics**](docs/StatisticsApi.md#get_business_airport_statistics) | **GET** /statistics/airports/business | Statistics for business flights on major airports
*StatisticsApi* | [**get_business_flights_statistics**](docs/StatisticsApi.md#get_business_flights_statistics) | **GET** /statistics/flights/business | Flights statistics (business)
*StatisticsApi* | [**get_commercial_airport_statistics**](docs/StatisticsApi.md#get_commercial_airport_statistics) | **GET** /statistics/airports/commercial | Statistics for commercial flights on major airports
*StatisticsApi* | [**get_commercial_flights_statistics**](docs/StatisticsApi.md#get_commercial_flights_statistics) | **GET** /statistics/flights/commercial | Flights statistics (commercial)
*StatisticsApi* | [**get_flights_statistics**](docs/StatisticsApi.md#get_flights_statistics) | **GET** /statistics/flights | Statistics for all flights
*StatisticsApi* | [**get_major_airport_statistics**](docs/StatisticsApi.md#get_major_airport_statistics) | **GET** /statistics/airports | Statistics for major airports


## Documentation For Models

 - [AirlineStatisticsResponse](docs/AirlineStatisticsResponse.md)
 - [AirportsStatisticsResponse](docs/AirportsStatisticsResponse.md)
 - [ApiAircraft](docs/ApiAircraft.md)
 - [ApiAircraftStatistic](docs/ApiAircraftStatistic.md)
 - [ApiAircraftTypeUtilization](docs/ApiAircraftTypeUtilization.md)
 - [ApiAircraftTypeUtilizationPeriod](docs/ApiAircraftTypeUtilizationPeriod.md)
 - [ApiAirlineStatistic](docs/ApiAirlineStatistic.md)
 - [ApiAirlineStatistics](docs/ApiAirlineStatistics.md)
 - [ApiAirport](docs/ApiAirport.md)
 - [ApiAirportStatistic](docs/ApiAirportStatistic.md)
 - [ApiAirportStatistics](docs/ApiAirportStatistics.md)
 - [ApiBusinessJetOperatorStatistic](docs/ApiBusinessJetOperatorStatistic.md)
 - [ApiBusinessJetOperatorStatistics](docs/ApiBusinessJetOperatorStatistics.md)
 - [ApiCoordinates](docs/ApiCoordinates.md)
 - [ApiDatis](docs/ApiDatis.md)
 - [ApiFlight](docs/ApiFlight.md)
 - [ApiFlightRouteStatistic](docs/ApiFlightRouteStatistic.md)
 - [ApiFlightsStatistic](docs/ApiFlightsStatistic.md)
 - [ApiJetModelStatistic](docs/ApiJetModelStatistic.md)
 - [ApiJetModelStatistics](docs/ApiJetModelStatistics.md)
 - [ApiMetar](docs/ApiMetar.md)
 - [ApiNatPacTrack](docs/ApiNatPacTrack.md)
 - [ApiNotam](docs/ApiNotam.md)
 - [ApiNotamTranslation](docs/ApiNotamTranslation.md)
 - [ApiRunway](docs/ApiRunway.md)
 - [ApiRunwayInUse](docs/ApiRunwayInUse.md)
 - [ApiStatisticAirport](docs/ApiStatisticAirport.md)
 - [ApiTaf](docs/ApiTaf.md)
 - [ApiTafForecast](docs/ApiTafForecast.md)
 - [ApiTafSkyCondition](docs/ApiTafSkyCondition.md)
 - [ApiTrackWaypoint](docs/ApiTrackWaypoint.md)
 - [ApiTrail](docs/ApiTrail.md)
 - [BillingStatusResponse](docs/BillingStatusResponse.md)
 - [BillingTokenDailyStats](docs/BillingTokenDailyStats.md)
 - [BillingUsageResponse](docs/BillingUsageResponse.md)
 - [BusinessJetModelStatisticsResponse](docs/BusinessJetModelStatisticsResponse.md)
 - [BusinessJetOperatorStatisticsResponse](docs/BusinessJetOperatorStatisticsResponse.md)
 - [Coordinates](docs/Coordinates.md)
 - [FlightsQuery](docs/FlightsQuery.md)
 - [FlightsResponse](docs/FlightsResponse.md)
 - [FlightsStatisticsResponse](docs/FlightsStatisticsResponse.md)
 - [GeoSearchQuery](docs/GeoSearchQuery.md)
 - [GetAircraftResponse](docs/GetAircraftResponse.md)
 - [GetAirportResponse](docs/GetAirportResponse.md)
 - [GetAirportsResponse](docs/GetAirportsResponse.md)
 - [GetDatisResponse](docs/GetDatisResponse.md)
 - [GetMetarResponse](docs/GetMetarResponse.md)
 - [GetNatPacTracksResponse](docs/GetNatPacTracksResponse.md)
 - [GetNotamsResponse](docs/GetNotamsResponse.md)
 - [GetTafResponse](docs/GetTafResponse.md)
 - [RtAircraftPositionQuery](docs/RtAircraftPositionQuery.md)
 - [ScheduledFlightsResponse](docs/ScheduledFlightsResponse.md)
 - [SearchAircraftResponse](docs/SearchAircraftResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerToken"></a>
### bearerToken

- **Type**: Bearer authentication


## Author




