# coding: utf-8

"""
    RadarBox On Demand API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.3.9
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GeoSearchQuery(BaseModel):
    """
    GeoSearchQuery
    """ # noqa: E501
    page_size: Optional[StrictInt] = Field(default=10, alias="pageSize")
    page: Optional[StrictInt] = 1
    min_latitude: Union[StrictFloat, StrictInt] = Field(alias="minLatitude")
    max_latitude: Union[StrictFloat, StrictInt] = Field(alias="maxLatitude")
    min_longitude: Union[StrictFloat, StrictInt] = Field(alias="minLongitude")
    max_longitude: Union[StrictFloat, StrictInt] = Field(alias="maxLongitude")
    below_altitude: Optional[StrictInt] = Field(default=None, alias="belowAltitude")
    above_altitude: Optional[StrictInt] = Field(default=None, alias="aboveAltitude")
    include_flight_paths: Optional[StrictBool] = Field(default=None, alias="includeFlightPaths")
    registrations: Optional[List[StrictStr]] = None
    mode_s_hex_codes: Optional[List[StrictStr]] = Field(default=None, alias="modeSHexCodes")
    from_date: datetime = Field(alias="fromDate")
    to_date: datetime = Field(alias="toDate")
    airlines: Optional[List[StrictStr]] = None
    aircraft_types: Optional[List[StrictStr]] = Field(default=None, alias="aircraftTypes")
    aircraft_classes: Optional[List[StrictStr]] = Field(default=None, alias="aircraftClasses")
    __properties: ClassVar[List[str]] = ["pageSize", "page", "minLatitude", "maxLatitude", "minLongitude", "maxLongitude", "belowAltitude", "aboveAltitude", "includeFlightPaths", "registrations", "modeSHexCodes", "fromDate", "toDate", "airlines", "aircraftTypes", "aircraftClasses"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GeoSearchQuery from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GeoSearchQuery from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pageSize": obj.get("pageSize") if obj.get("pageSize") is not None else 10,
            "page": obj.get("page") if obj.get("page") is not None else 1,
            "minLatitude": obj.get("minLatitude"),
            "maxLatitude": obj.get("maxLatitude"),
            "minLongitude": obj.get("minLongitude"),
            "maxLongitude": obj.get("maxLongitude"),
            "belowAltitude": obj.get("belowAltitude"),
            "aboveAltitude": obj.get("aboveAltitude"),
            "includeFlightPaths": obj.get("includeFlightPaths"),
            "registrations": obj.get("registrations"),
            "modeSHexCodes": obj.get("modeSHexCodes"),
            "fromDate": obj.get("fromDate"),
            "toDate": obj.get("toDate"),
            "airlines": obj.get("airlines"),
            "aircraftTypes": obj.get("aircraftTypes"),
            "aircraftClasses": obj.get("aircraftClasses")
        })
        return _obj


